
jQuery(document).ready(function() {
	jQuery('[data-plugin]').each(function(){
		if (jQuery(this).attr('data-plugin') == 'book-an-appointment') {
            var token = jQuery(this).attr('data-token');
    		if (typeof token !== 'undefined' && token !== null) {
    			var variables = eval('book_an_appointment_variables_' + token);
    			book_an_appointment_961_draw_month(token, variables.now);
                // book_an_appointment_961_setFruits(token);
                add_robot_filter_block(token);
                book_an_appointment_961_check_complete(token);
    		}
		}
	});
});

jQuery('.appointment-form').submit (function() {
    var token = jQuery(this).closest('.book-an-appointment').attr('data-token');
    var days = [];
    jQuery('#book_an_appointment_'+token).find('.appointment-month').find('.on-select').each(function() {
        days.push( jQuery(this).attr('data-day') );
    });

    var form_data = {};
    // Find inputs
    jQuery('#book_an_appointment_'+token).find('.appointment-form').find('input').each(function(){
        var name = jQuery(this).attr('name');
        if (!jQuery(this).hasClass('no-save')) { 
            var text = jQuery(this).val();
            text = text.replace(/(<([^>]+)>)/ig,"");
            form_data[name] = text; 
        }
    });    
    // Find textarea
    jQuery('#book_an_appointment_'+token).find('.appointment-form').find('textarea').each(function(){
        var name = jQuery(this).attr('name');
        if (!jQuery(this).hasClass('no-save') && name != 'g-recaptcha-response') { 
            var text = jQuery(this).val();
            text = text.replace(/(<([^>]+)>)/ig,"");
            form_data[name] = text; 
        }
    });    

    var data = {
            action   : 'book_an_appointment_961_save_appointment_function',
            id       : jQuery(this).closest('.book-an-appointment').attr('data-id'),
            days     : JSON.stringify(days),
            time     : jQuery('#book_an_appointment_'+token).find('.appointment-times').find('.on-select:first').attr('data-time'),
            data     : JSON.stringify(form_data),
            token    : token
        };
        
    data = robot_filter_get_values(data);

    var h = jQuery('#book_an_appointment_'+token).find('.appointment-form').height();
    jQuery('#book_an_appointment_'+token).find('.appointment-form').closest('div').height(h);
    jQuery('#book_an_appointment_'+token).find('.appointment-form').fadeOut(200);
    setTimeout(function(){
        jQuery('#book_an_appointment_'+token).find('.appointment-form').closest('div').prepend('<div class="book_an_appointment_wait"></div>');
    }, 210);

    jQuery.ajax({
        url      : book_an_appointment_961_ajax_object.ajax_url,
        dataType : 'json',
        type     : 'POST',
        data     : data,
        success  : function(data, result){
            jQuery('#book_an_appointment_'+data.token).find('.appointment-form').closest('div').find('.book_an_appointment_wait').remove();
            if (data.status == 1) {
                jQuery('#book_an_appointment_'+data.token).find('.appointment-form').html(data.html);
                jQuery('#book_an_appointment_'+data.token).find('.appointment-form').fadeIn(200);
            } else {
                jQuery('#book_an_appointment_'+data.token).find('.appointment-form').closest('div').prepend('<div class="book_an_appointment_error">'+data.html+'</div>');
                setTimeout(function(){ 
                    jQuery('#book_an_appointment_'+data.token).find('.appointment-form').closest('div').find('.book_an_appointment_error').remove();
                    jQuery('#book_an_appointment_'+data.token).find('.appointment-form').fadeIn(200); 
                    // book_an_appointment_961_setFruits(data.token);
                    jQuery('#book_an_appointment_'+data.token).find('.robot-container').remove();
                    add_robot_filter_block(data.token);
                    book_an_appointment_961_check_complete(data.token);
                }, 5000);             
                if (data.time != '') {
                    jQuery('#book_an_appointment_'+data.token).find('.appointment-times').find('.on-select').remove();
                } else {
                    book_an_appointment_961_draw_month(data.token, data.month);
                }
                book_an_appointment_961_check_complete(data.token);   
            }
        },
        error: function (request, status, error) {
            alert('AJAX error : ' + status);
        } 
    });
    
    return false;
});


function book_an_appointment_961_set_month(item, now) {
    var token = item.closest('.book-an-appointment').attr('data-token');
    var appointment_id  = item.closest('.book-an-appointment').attr('data-id');

    if ( item.closest('.book-an-appointment').attr('data-events') == '1') {
        jQuery('#book_an_appointment_'+token).find('.appointment-month').fadeOut(200);
        setTimeout(function(){ 
            jQuery('#book_an_appointment_'+token).find('.appointment-month').html('<div class="book_an_appointment_wait"></div>');
            jQuery('#book_an_appointment_'+token).find('.appointment-month').show(); 
        }, 210);
    } else {
        item.html('<div class="book_an_appointment_wait_icon"></div>');
    }
    
    var variables = eval('book_an_appointment_variables_' + token);
    var data = {
            action : 'book_an_appointment_961_render_month',
            now     : now,
            id      : appointment_id,
            odd     : JSON.stringify(variables.odd),
            couple  : JSON.stringify(variables.couple),
            token   : token
        };
    jQuery.ajax({
        url      : book_an_appointment_961_ajax_object.ajax_url,
        dataType : 'json',
        type     : 'POST',
        data     : data,
        success  : function(data, result){
            if (data.status == 1) {
                // Status OK
                //jQuery('#book_an_appointment_'+token).find('.appointment-month').hide();
                if ( jQuery('#book_an_appointment_'+data.token).attr('data-events') == '1') {
                    jQuery('#book_an_appointment_'+data.token).find('.appointment-month').hide();
                    jQuery('#book_an_appointment_'+data.token).find('.appointment-month').html(data.html);
                    jQuery('#book_an_appointment_'+data.token).find('.appointment-month').fadeIn();
                } else {
                    jQuery('.book_an_appointment_wait_icon').remove();
                    jQuery('#book_an_appointment_'+data.token).find('.appointment-month').append(data.html);
                }
                book_an_appointment_961_set_selectable(jQuery('#book_an_appointment_'+data.token).find('.selectable:first'));

            } else {
                console.log(data);
            }
        },
        error: function (request, status, error) {
            alert('AJAX error : ' + status);
        } 
    });

}

function book_an_appointment_961_draw_month(token, now) {

    var variables = eval('book_an_appointment_variables_' + token);

    var data = {
            action  : 'book_an_appointment_961_draw_month_function',
            now     : now,
            id      : jQuery('#book_an_appointment_'+token).attr('data-id'),
            odd     : JSON.stringify(variables.odd),
            couple  : JSON.stringify(variables.couple),
            token   : token
        };

    jQuery.ajax({
        url      : book_an_appointment_961_ajax_object.ajax_url,
        dataType : 'json',
        type     : 'POST',
        data     : data,
        success  : function(data, result){
            jQuery('#book_an_appointment_'+data.token).find('.appointment-times').html('');
            if (data.status == 1) {
                // Status OK
                jQuery('#book_an_appointment_'+data.token).find('.appointment-month').html(data.html);
                jQuery('#book_an_appointment_'+data.token).attr('data-events', data.show_events);
            } else {
                console.log(data);
            }
        },
        error: function (request, status, error) {
            alert('AJAX error : ' + status);
        } 
    });
}

function book_an_appointment_961_toYYYYMMDD(d) {
    var yyyy = d.getFullYear();
    var mm = (d.getMonth() + 101).toString().slice(-2);
    var dd = (d.getDate() + 100).toString().slice(-2);
    return yyyy + '-' + mm + '-' + dd;
}

function book_an_appointment_961_set_selectable(item) {

    console.log(item.closest('.book-an-appointment').find('.on-select').length);
    if (item.closest('.book-an-appointment').find('.on-select').length > 0) {

        var first = '9999-12-31';
        var last = '0000-01-01';
        item.closest('.book-an-appointment').find('.on-select').each(function() {
            if ( jQuery(this).attr('data-day') < first ) {
                first = jQuery(this).attr('data-day');
            }           
            if ( jQuery(this).attr('data-day') > last ) {
                last = jQuery(this).attr('data-day');
            } 
            console.log(first);
            console.log(last);
                      
        });

        first = new Date(first+'T00:00:00');
        first = new Date(first.getTime()-1000*60*60*24);
        first = book_an_appointment_961_toYYYYMMDD(first);

        last = new Date(last+'T00:00:00');
        last = new Date(last.getTime()+1000*60*60*24);
        last = book_an_appointment_961_toYYYYMMDD(last);
        
        item.closest('.book-an-appointment').find('.selectable').each(function() {
            
            var index = jQuery(this).attr('data-day');
            if (first <= index && index <= last) {
                jQuery(this).removeClass('not-select');
            } else {
                jQuery(this).addClass('not-select');
            }
                        
        });
        
    } else {
        item.closest('.book-an-appointment').find('.selectable').removeClass('not-select');
    }
    
}

function book_an_appointment_961_on_select(item) {

    if ( item.closest('.book-an-appointment').attr('data-events') != '1') {
        if (item.hasClass('on-select')) {
            item.removeClass('on-select');
        } else {
            if (!item.hasClass('not-select')) {
                item.addClass('on-select');
            }
        }
        book_an_appointment_961_set_selectable(item);
        
    } else {
        item.closest('.appointment-month').find('.on-select').removeClass('on-select');
        item.addClass('on-select');      
        book_an_appointment_961_show_times(item.attr('data-day'), item.closest('.book-an-appointment').attr('data-token'));  
    }
    book_an_appointment_961_check_complete(item.closest('.book-an-appointment').attr('data-token'));
}

function book_an_appointment_961_show_times(day, token) {

    jQuery('#book_an_appointment_'+token).find('.appointment-times').html('<div class="book_an_appointment_wait_icon"></div>');
    var variables = eval('book_an_appointment_variables_' + token);
    
    var data = {
            action   : 'book_an_appointment_961_show_times_function',
            day      : day,
            odd      : JSON.stringify(variables.odd),
            couple   : JSON.stringify(variables.couple),
            holidays : JSON.stringify(variables.holidays),
            id       : jQuery('#book_an_appointment_'+token).attr('data-id'),
            token    : token
        };
    jQuery.ajax({
        url      : book_an_appointment_961_ajax_object.ajax_url,
        dataType : 'json',
        type     : 'POST',
        data     : data,
        success  : function(data, result){
            if (data.status == 1) {
                // Status OK
                jQuery('#book_an_appointment_'+data.token).find('.appointment-times').html(data.html);
                
            } else {
                console.log(data);
            }
        },
        error: function (request, status, error) {
            alert('AJAX error : ' + status);
        } 
    });
}

function book_an_appointment_961_on_select_time(item) {
    item.closest('.appointment-times').find('.on-select').removeClass('on-select');
    item.addClass('on-select');  
    book_an_appointment_961_check_complete(item.closest('.book-an-appointment').attr('data-token'));    
}

function book_an_appointment_961_check_complete(token) {
    var complete = true;
    var days = jQuery('#book_an_appointment_'+token).find('.appointment-month').find('.on-select');
    if (days.length < 1) {
        complete = false;
    }   
    if ( jQuery('#book_an_appointment_'+token).attr('data-events') == '1') {
        var times = jQuery('#book_an_appointment_'+token).find('.appointment-times').find('.on-select');
        if (times.length < 1) {
            complete = false;
        }   
    }
    
    if (complete) {
        jQuery('#book_an_appointment_'+token).find('.booking_button').prop('disabled', false);        
    } else {
        jQuery('#book_an_appointment_'+token).find('.booking_button').prop('disabled', true);
    }
}

function book_an_appointment_961_call_ajax_sample(token, data) {

    var data = {
            action : 'book_an_appointment_961_call_ajax_function',
            variables : data,
            token     : token
        };

    jQuery.ajax({
        url      : book_an_appointment_961_ajax_object.ajax_url,
        dataType : 'json',
        type     : 'POST',
        data     : data,
        success  : function(data, result){
            if (data.status == 1) {
                // Status OK
                jQuery('#book_an_appointment_'+data.token).find('.appointment-mont').html(data.html);
            } else {
                console.log(data);
            }
        },
        error: function (request, status, error) {
            alert('AJAX error : ' + status);
        } 
    });
}

