<?php 

    global $wpdb;

    $step  = get_post_meta($id, 'appointment_mins', true);

    if ((isset($_REQUEST['date'])) || (!empty($_REQUEST['date']))) {
        $month = sanitize_text_field($_REQUEST['date']);
        $stamp = strtotime($month);
        if (is_numeric($stamp)){  
            $m = date( 'm', $stamp ); 
            $d = date( 'd', $stamp ); 
            $y = date( 'Y', $stamp ); 
            if (!checkdate($m, $d, $y)) {
                $month = date('Y-m-01'); 
            } else {
                $month = date('Y-m-d', strtotime($y.'-'.$m.'-01'));
            }; 
        } else {
            $month = date('Y-m-01');
        }         
    } else {
        $month = date('Y-m-01');
    }

    $options = book_an_appointment_961_get_options();
    $holidays = explode(',', str_replace(' ', '', $options['holiday']));
    $works    = explode(',', str_replace(' ', '', $options['work']));    
    $weekends = explode(',', str_replace(' ', '', $options['free']));
    $disabled = explode(',', str_replace(' ', '', get_post_meta($id, 'appointment_disabled', true)));

    // Prev link
    $prev_month = date('Y-m-d', strtotime('-1 month', strtotime($month))); 
    $inputs[] = '<button type="button" class="setWeek button" data-value="'.$prev_month.'">' .
                    '<span class="dashicons dashicons-arrow-left-alt2"></span>' .
                    '<span>'.date_i18n('F', strtotime($prev_month)).'</span>'.
                '</button>';
    
    // Date selector
    $inputs[] = '<input type="date" name="date" id="browse_books_date" value="'.$month.'" onchange="jQuery(this).closest(\'form\').submit();" />';    

    // Next link
    $next_month = date('Y-m-d', strtotime('+1 month', strtotime($month))); 
    $inputs[] = '<button type="button" class="setWeek button" data-value="'.$next_month.'">' .
                    '<span>'.date_i18n('F', strtotime($next_month)).'</span>'.
                    '<span class="dashicons dashicons-arrow-right-alt2"></span>' .
                '</button>';

    $calendar  = get_post_meta($id, 'appointment_calendar', true);
                
?>
<div class="tablenav top">
    <div class="booking-browse-navigation">
        <form action="edit.php">
        <?php echo implode("\r\n", $inputs);?>
        </form>
    </div>
</div>
<div style="padding-top: 20px;margin-right: 20px;">
    <div class="month">
        <table class="booking-table">
        <thead>
            <tr>
                <?php
                $first  = date('N', strtotime($month));
                $start_of_week = get_option( 'start_of_week' );
                $index = date_i18n('Y-m-d', strtotime('-'.($first - $start_of_week).' day', strtotime($month)));
                for ($i = 0; $i <= 6; $i++) {
                	echo '<th class="calendar-dayname">'.date_i18n('l', strtotime($index)).'</th>';
                    $index = date_i18n('Y-m-d', strtotime('+1 day', strtotime($index)));
                }
                ?>
            </tr>
        </thead>
        <tr>
            <?php
                $col = 1;
                $first  = date('N', strtotime($month));
                $days   = date('t', strtotime($month));
                $actual = date('Y-m-d', strtotime($month));
                $disabled = explode(',', str_replace(' ', '', get_post_meta($id, 'appointment_disabled', true)));
                
                for ($i = 0; $i < ($first - $start_of_week); $i++) {
                	echo '<td class="no-border">'.'&nbsp;'.'</td>';
                    $col++;
                }
                
                $query = 'SELECT * FROM ' . $wpdb->prefix.'bookanappointment ' .
                            'WHERE ' . 
                                '`place_id` = "'.$id.'" AND ' .
                                '`date` LIKE "'.date('Y-m').'%"';
                $result = $wpdb->get_results($query, ARRAY_A);
                if (!empty($result)) {
                    
                    $books = array();    
                    foreach ($result as $item) {
                        if (isset($books[$item['date']])) {
                            $books[$item['date']][] = $item;
                        } else {
                            $books[$item['date']][] = $item; 
                        }
                    }
                }    
    
                $options = book_an_appointment_961_get_options();
                $holidays = explode(',', str_replace(' ', '', $options['holiday']));
                $works    = explode(',', str_replace(' ', '', $options['work']));    
                $weekends = explode(',', str_replace(' ', '', $options['free']));
    
                
                for ($i = 1; $i <= $days; $i++) {
                    $class = array('booking-content');
    
                    if (in_array($actual, $disabled)) {
                        $class[] = 'booking-reserved';    
                    }
    
                    // Check the holiday
                    if (in_array($actual, $holidays)) {
                        $class[] = 'holiday';  
                    }
                    
                    // Check the weekend
                    $is_weekend = false;
                    if (in_array($actual, $weekends)) {
                        $is_weekend = true;
                    } else {
                        $n = date('N', strtotime($actual));
                        if ($n > 5) {
                            if (!in_array($actual, $works)) {
                                $is_weekend = true;
                            }
                        }            
                    }
                    if ($is_weekend) {
                        $class[] = 'weekend';   
                    }
                    
                    // Check the business day
                    $is_business = false;
                    if (in_array($actual, $works)) {
                        $is_business = true;
                    } else {
                        $n = date('N', strtotime($actual));
                        if ($n <= 5) {
                            if (!in_array($actual, $weekends)) {
                                if (!in_array($actual, $holidays)) {
                                    $is_business = true;
                                }
                            }
                        }            
                    }
                    if ($is_business) {
                        $class[] = 'work';
                    }
                    
                
    
                	echo  '<td class="'.implode(' ', $class).'">'.
                          '<div class="calendar-day">'.date('d', strtotime($actual)).'</div>'.
                          '<div style="clear:both"></div>';
    
                    if (isset($actual, $books)) {
                        $booking = array();
                        
                        if (isset($books[$actual])) {
                        
                            foreach ($books[$actual] as $item) {
                                $content = apply_filters('book_an_appointment_961_booking_content', $item['data']); 
                                if ($item['time'] != '00:00') {
                                    $content = '<div class="small">'.$item['time'].'</div>'.$content;
                                }
                                
                                $icons = array();
                                
                                $class = array('books-item');
                                if (!empty($item['accept'])) {
                                    $class[] = 'booking-accepted';
                                    $icons[] = '<span onclick="book_an_appointment_961_action_show_delete_box(jQuery(this),\''.$item['token'].'\')" class="booking-action dashicons dashicons-trash" title="'.__('Delete booking', 'book-an-appointment').'"></span>'; 
                                } else {
                                    if (!empty($item['confirm'])) {
                                        $class[] = 'booking-confirmed';
                                        $icons[] = '<span onclick="book_an_appointment_961_action_accept(jQuery(this), \''.$item['token'].'\')" class="booking-action dashicons dashicons-saved" title="'.__('Accept booking', 'book-an-appointment').'"></span>';
                                        $icons[] = '<span onclick="book_an_appointment_961_action_show_delete_box(jQuery(this),\''.$item['token'].'\')" class="booking-action dashicons dashicons-trash"title="'.__('Delete booking', 'book-an-appointment').'"></span>';
                                    } else {
                                        $class[] = 'booking-pending';
                                    }                                            
                                }

                                if ((((!empty($item['accept'])) or (!empty($item['confirm'])))) and 
                                    (empty($item['calendar_id'])) and 
                                    (!empty($options['calendar']['token'])) and 
                                    (!empty($calendar))) {
                                    $icons[] = '<span onclick="book_an_appointment_961_action_save_google(jQuery(this), \''.$item['token'].'\')" class="booking-action dashicons dashicons-calendar-alt" title="'.__('Save to Google Calendar', 'book-an-appointment').'"></span>';
                                }
                                
                                if (!empty($icons)) {
                                    $content .= '<hr />' .
                                                '<div style="text-align:right;">'. implode('', $icons).'</div>';
                                }
                                $booking[] = '<div class="bg-white" data-token="'.$item['token'].'">'.
                                             '<div class="'.implode(' ', $class).'">'.$content.'</div>'.
                                             '</div>';
                            }
                            echo implode('', $booking);
                        }
                        
                    }
    
                    echo '</td>';
    
                    $actual = date('Y-m-d', strtotime('+1 day', strtotime($actual)));
                    $col++;
                    if ($col > 7) {
                        echo '</tr><tr>';
                        $col = 1;
                    }
                    
                }
                
                for ($i = $col; $i <= 7; $i++) {
                    echo '<td class="no-border">'.'&nbsp;'.'</td>';
                }
    
            ?>    
        </tr>
        </table>
    </div>
</div>    
    