<?php

    $id = '';
    if (isset($_REQUEST['id'])) {
        $id = absint(intval( sanitize_text_field($_REQUEST['id']) ));   
        if (!is_int($id)) {
            $id = '';
        } 
    } 

    $args = array(
            'numberposts' => -1,
            'post_type'	  => 'booking-place',
            'orderby'     => 'title',
            'order'       => 'ASC'  
        );
    $source = get_posts($args);
    $places = array();
    foreach ($source as $item) {
        $places[$item->ID] = $item->post_title;
    }

    $inputs = array();
    $inputs[] = '<input type="hidden" name="post_type" value="booking-place" />';
    $inputs[] = '<input type="hidden" name="page" value="browse_books" />';
    
    if (!empty($places)) {
        $text = '<select id="id" name="id" onchange="jQuery(this).closest(\'form\').submit();">' . 
                '<option value="0" '.selected($id, '0', false).'>' .
                    __('--== All places ==--', 'book-an-appointment') . 
                '</option>';
        foreach( $places as $key => $title ) {
            $text .= '<option value="'.$key.'" '.selected($id, $key, false).'>'.$title.'</option>';    
        }
        $text .= '</select>';
        $inputs[] = $text;
    }

?>
<h1 class="wp-heading-inline">
    <?php echo __('Browse books', 'book-an-appointment');?>
</h1>

<?php
if (empty($places)) {
    echo __('There are no places to display.', 'book-an-appointment') .
         '<a href="/wp-admin/edit.php?post_type=booking-place">'. __('Be the first to create places by clicking here.', 'book-an-appointment').'</a>';
} else {

    if (empty($id)) {
        echo __('Please, select place first!', 'book-an-appointment') . '&nbsp;' .
             '<form action="edit.php">' . "\r\n" . 
             implode("\r\n", $inputs) . 
             '</form>'; 
    } else {
        $type = get_post_meta($id, 'appointment_reservation', true);
        if ($type == 'time') {
            include(dirname(__file__) .DIRECTORY_SEPARATOR. 'browse-books-time.php');
        } else {
            include(dirname(__file__) .DIRECTORY_SEPARATOR. 'browse-books-day.php');
        }
        
        $legends = array();
        $legends[] = '<span class="booking-reserved">&nbsp;</span>&nbsp;' . __('Reserved', 'book-an-appointment');
        $legends[] = '<span class="booking-pending">&nbsp;</span>&nbsp;' . __('User confirmation pending', 'book-an-appointment');
        $legends[] = '<span class="booking-confirmed">&nbsp;</span>&nbsp;' . __('User confirmed', 'book-an-appointment');
        $legends[] = '<span class="booking-accepted">&nbsp;</span>&nbsp;' . __('Admin accepted', 'book-an-appointment');
        
        echo '<div class="booking-legend">' .
                implode('&nbsp;&nbsp;|&nbsp;&nbsp;', $legends) .
             '</div>';
    
    }

} 
?>
<div id="books_messageBox" class="books_messageBox" style="display:none;">
    <label for="book_resignation_description"><?php echo __('Resignation message:', 'book-an-appointment');?></label><br />
    <textarea id="book_resignation_description" name="book_resignation_description" style="width:300px;"></textarea>
    <input type="hidden" id="book_resignation_token" name="book_resignation_token" value="" />
    <div style="text-align:center"> 
        <button onclick="book_an_appointment_961_action_delete();" class="button button-primary"><?php echo __('Resignation', 'book-an-appointment');?></button>&nbsp;
        <button onclick="book_an_appointment_961_action_cancel();" class="button"><?php echo __('Cancel', 'book-an-appointment');?></button>
    </div>
</div>
<div style="clear: both;"></div>
