<?php

    global $wpdb;
    
    $table_name = $wpdb->prefix . 'bookanappointment';
    $query = 'SELECT COLUMN_NAME AS `name` FROM INFORMATION_SCHEMA.COLUMNS WHERE table_name = "'.$table_name.'" AND COLUMN_NAME = "calendar_id"';
    $cols = $wpdb->get_results($query);
    
    if (empty($cols)) {
        
        $query = 'ALTER TABLE `'.$table_name.'` ADD `calendar_id` TEXT NOT NULL AFTER `token`;';
        $wpdb->query($query);
        
    }
    

    $options = book_an_appointment_961_get_options();

    if ((!isset($options['calendar']['code'])) or (empty($options['calendar']['code']))) {
        echo '<h3><span class="dashicons dashicons-dismiss" style="color: #DB0000;font-size: 42px;margin-top: -12px;width: 42px;"></span> '. __('Google calendar not connected', 'book-an-appointment').'</h3>';
    } else {
        echo '<h3><span class="dashicons dashicons-yes-alt" style="color: #01C201;font-size: 42px;margin-top: -12px;width: 42px;"></span> '. __('Google calendar connected', 'book-an-appointment').'</h3>';
    }
    ?>
    <div>
        <?php echo sprintf(__('To use the calendar, you will need a Google API key, which you can register by <a href="%s" target="_blank">clicking here</a>.', 'book-an-appointment'), 'https://console.developers.google.com/apis');?><br />        
        <?php echo sprintf(__('In the "Authorized redirect URIs" section, you must enable the address <code>%s</code>.', 'book-an-appointment'), home_url('/').'booking-calendar');?>        
    </div>
    <table class="form-table" role="presentation">
        <tbody>
            <tr>
                <th scope="row">
                    <?php echo __('Google client ID:', 'book-an-appointment');?>
                </th>
                <td>
                    <input type="text" id="site_key" value="<?php echo $options['calendar']['key'];?>" style="width: 100%;" />
                </td>
            </tr>
            <tr>
                <th scope="row">
                    <?php echo __('Google client secret:', 'book-an-appointment');?>
                </th>
                <td>
                    <input type="text" id="secret_key" value="<?php echo $options['calendar']['secret'];?>" style="width: 100%;" />
                </td>
            </tr>
        </tbody>
    </table>
    <button id="google_save_button" onclick="book_an_appointment_961_save_google();" type="button" class="button button-primary">
        <span class="dashicons dashicons-google" style="margin-top: 3px;"></span>
        <?php echo __('Save and connect to Google Calendar', 'book-an-appointment');?>
    </button>
    
    <button id="google_unlink_button" onclick="book_an_appointment_961_unlink_google();" type="button" class="button">
        <span class="dashicons dashicons-editor-unlink" style="margin-top: 3px;"></span>
        <?php echo __('Disconnect', 'book-an-appointment');?>
    </button>
    <?php
	