<?php

    if ( !defined( 'ABSPATH' ) ) exit;

    class JBookAnAppointment961 extends stdClass
    {
        private $options = null;
        private $args = null;
        
        public function __construct($options, $shorcode_args)
        {
            $this->args = $shorcode_args;
            
            $this->options = $options;
            $this->options['token'] = $this->getToken();

            $args = [
                'post_type'      => 'booking-place',
                'posts_per_page' => 1,
                'post_name__in'  => [$this->options['target']]
            ];
            $posts = get_posts( $args );
            $this->options['data-id'] = $posts[0]->ID; 

            $type = get_post_meta($this->options['data-id'], 'appointment_reservation', true);
            $odd = array();
            $couple = array();
            $holidays = array();
            if ($type == 'time') {
                $reserved = explode(',', str_replace(' ', '', get_post_meta($this->options['data-id'], 'appointment_reserved', true)));
                $start = get_post_meta($this->options['data-id'], 'appointment_odd_on_time', true);
                $end   = get_post_meta($this->options['data-id'], 'appointment_odd_off_time', true);
                $step  = get_post_meta($this->options['data-id'], 'appointment_mins', true);
                if (($start != '') and ($end != '') and ($step != '')) {
                    $odd = array();
                    if (!in_array($start, $reserved)) {
                        $odd[] = $start;
                    }                    
                    while ($start < $end) {
                        $start = date('H:i', strtotime('+'.$step.' mins', strtotime($this->options['now'].'-01 '.$start.':00')));
                        if (!in_array($start, $reserved)) {
                            $odd[] = $start;
                        }
                    }
                }
                $start = get_post_meta($this->options['data-id'], 'appointment_couple_on_time', true);
                $end   = get_post_meta($this->options['data-id'], 'appointment_couple_off_time', true);
                if (($start != '') and ($end != '') and ($step != '')) {
                    $couple = array();
                    if (!in_array($start, $reserved)) {
                        $couple[] = $start;
                    }                    
                    while ($start < $end) {
                        $start = date('H:i', strtotime('+'.$step.' mins', strtotime($this->options['now'].'-01 '.$start.':00')));
                        if (!in_array($start, $reserved)) {
                            $couple[] = $start;
                        }
                    }
                }
                $start = get_post_meta($this->options['data-id'], 'appointment_holiday_on_time', true);
                $end   = get_post_meta($this->options['data-id'], 'appointment_holiday_off_time', true);
                if (($start != '') and ($end != '') and ($step != '')) {
                    $holidays = array();
                    if (!in_array($start, $reserved)) {
                        $holidays[] = $start;
                    }                    
                    while ($start < $end) {
                        $start = date('H:i', strtotime('+'.$step.' mins', strtotime($this->options['now'].'-01 '.$start.':00')));
                        if (!in_array($start, $reserved)) {
                            $holidays[] = $start;
                        }
                    }
                }
            }

            $ajax_vars = array(
                    'slug'     => $this->options['target'],
                    'now'      => $this->options['now'],
                    'token'    => $this->options['token'],
                    'data-id'  => $this->options['data-id'],
                    'odd'      => $odd,
                    'couple'   => $couple,
                    'holidays' => $holidays
                );

            // Javascript változók átadása
            // Set the javascript values
            if (count($ajax_vars) > 0) {
    			wp_register_script('book-an-appointment-'.$this->options['token'].'-variables-js', '', array('jquery'), false, true);
    			wp_localize_script('book-an-appointment-'.$this->options['token'].'-variables-js', 'book_an_appointment_variables_'.$this->options['token'], $ajax_vars);
    			wp_enqueue_script('book-an-appointment-'.$this->options['token'].'-variables-js');
            }

            if (($this->options['filter_type'] != 'fruits') and (!empty($this->options['google_site_key'])) and (!empty($this->options['google_secret_key']))) {
                wp_register_script('robot-filter-js', plugins_url( 'book-an-appointment/assets/js/robot-filter-google.js', BOOK_AN_APPOINTMENT_961_ROOT ), array('jquery'));
                wp_add_inline_script( 'robot-filter-js', 'var google_filter_site_key = "'.$this->options['google_site_key'].'";', 'before' );

                wp_enqueue_script('robot-filter-js' );
                wp_register_script('google-filter-js', 'https://www.google.com/recaptcha/api.js', array('jquery'));
                wp_enqueue_script('google-filter-js' );
            
            } else {
                $this->options['filter_type'] = 'fruits';                
            }
                
            
            if ($this->options['filter_type'] == 'fruits') {
                $fruits_data = explode('|', __('apple|banana|blackberry|cherry|orange|pear|plum|raspberry|strawberry|lemon|peach|grapes|apricot|watermelon|coconut|melon|pineapple|kiwi', 'book-an-appointment'));
                wp_register_style('robot-filter', plugins_url( 'book-an-appointment/assets/css/robot-filter.css', BOOK_AN_APPOINTMENT_961_ROOT ) );
    			wp_enqueue_style( 'robot-filter' );
                
                wp_register_script('robot-filter-js', plugins_url( 'book-an-appointment/assets/js/robot-filter.js', BOOK_AN_APPOINTMENT_961_ROOT ), array('jquery'));
                wp_localize_script('robot-filter-js', 'fruits', $fruits_data);
                wp_add_inline_script( 'robot-filter-js', 'var fruits_url = "'.plugins_url( 'book-an-appointment/assets/images/' ).'";', 'before' );
                wp_add_inline_script( 'robot-filter-js', 'var filter_text = "'.__('We need to make sure that you are not a robot. Therefore, we ask you to mark the following fruit:', 'book-an-appointment').'";', 'before' );
                wp_add_inline_script( 'robot-filter-js', 'var filter_error = "'. __('<strong>Error checking robot!</strong> The selected fruit is not suitable.', 'book-an-appointment').'";', 'before' );
/*
                wp_localize_script('robot-filter-js', 'fruits_url', plugins_url( 'book-an-appointment/assets/images/' ));
                wp_localize_script('robot-filter-js', 'filter_text', __('We need to make sure that you are not a robot. Therefore, we ask you to mark the following fruit:', 'book-an-appointment'));
                wp_localize_script('robot-filter-js', 'filter_error', __('<strong>Error checking robot!</strong> The selected fruit is not suitable.', 'book-an-appointment'));
*/
            	wp_enqueue_script('robot-filter-js' );
            }
            
        }

        private function getToken()
        {
            $chars = 'ABCDEFGHIJKLMNOPQURSTXYVWZ0123456789';
            $token = '';
            for ($i = 1; $i <= 10; $i++) {
            	$token .= substr($chars, rand(0, strlen($chars)-1), 1);
            }                
            return $token;
        }

        function prepareContent()
        {   

            $this->args = apply_filters('book_an_appointment_modify_args_before_form_render', $this->args);

            if (!class_exists('JDovi42_Templates')) {
                include_once(BOOK_AN_APPOINTMENT_961_ROOT . '/libs/jdovi42_templates.php');
            }
            $tmpl = new JDovi42_Templates(BOOK_AN_APPOINTMENT_961_ROOT);
            $tmpl->useTemplate('booking-form-single.html');
            $tmpl->setOptions($this->args);

            $template = $tmpl->prepareContent();

            $template = str_replace('[NAME]', __('Your name:', 'book-an-appointment'), $template);
            $template = str_replace('[EMAIL]', __('Your email:', 'book-an-appointment'), $template);
            $template = str_replace('[EMAIL_DESCRIPTION]', __('We will send a confirmation link to this address.', 'book-an-appointment'), $template);
            $template = str_replace('[PHONE]', __('Your phone:', 'book-an-appointment'), $template);
            $template = str_replace('[MESSAGE]', __('Your message:', 'book-an-appointment'), $template);
            $gdpr = sprintf( __('I accept the <a href="%s" target="_blank">privacy policy</a>.', 'book-an-appointment'), get_privacy_policy_url()); 
            $template = str_replace('[GDPR]', $gdpr, $template);
            $template = str_replace('[BOOKING]', __('I\'m booking', 'book-an-appointment'), $template);

            $html = "\r\n" .
                    '<div id="book_an_appointment_'.$this->options['token'].'" class="book-an-appointment" data-plugin="book-an-appointment" data-token="'.$this->options['token'].'" data-id="'.$this->options['data-id'].'" data-slug="'.$this->options['target'].'">' . "\r\n" .
                    $template .
                    '</div>' . "\r\n";
                
            return $html;
        }
        
    }