<?php

require_once( dirname(__file__) . '/inputs-class.php' );

if ( ! class_exists( 'Dovi42_Meta_Box_Input_UserGroups') ) :

    class Dovi42_Meta_Box_Input_UserGroups extends Dovi42_Meta_Box_Inputs  {

        var $options = array();

        public function __construct($options)
        {
            parent::__construct($options);
        }

        function render($post_id) {
            
            global $wp_roles;
            
            parent::render($post_id);

            if ((!isset($this->options['mode'])) or (empty($this->options['mode']))) {
                $this->options['mode'] = 'checkbox';
            }

            $this->value = explode(',', $this->value);

            $html = '<tr>' . "\r\n" . 
                    "\t" . '<td>' . "\r\n" . 
                    "\t\t" . '<label for="'.$this->options['id'].'">'.$this->options['label'].'</label>' . "\r\n" . 
                    "\t" . '</td>' . "\r\n" .
                    "\t" . '<td>' . "\r\n"; 

            $all_roles = $wp_roles->roles;
            foreach ($all_roles as $key => $role) {

                $checked = '';
                if (in_array($key, $this->value)) {
                    $checked = 'checked="checked"';
                }

                $html .= 
                    "\t\t" . '<div style="display: inline-block;margin-right:20px;">' . "\r\n" .
                    "\t\t" . '<label>' . "\r\n" . 
                    "\t\t\t" . '<input type="'.$this->options['mode'].'" name="'.$this->options['meta_key'].'_'.$this->options['id'].'[]" '.$checked.' value="'.$key.'" data-type="checkbox" />' . "\r\n" .
                    "\t\t\t" . translate_user_role($role['name']) . "\r\n" . 
                    "\t\t" . '<label>' . "\r\n" .
                    "\t\t" . '</div>' . "\r\n" ; 
            }
            if ((isset($this->options['description'])) and (!empty($this->options['description']))) {
                    $html .= "\t\t" . '<div class="description small">'.$this->options['description'].'</div>' . "\r\n";
            } 
            $html .= "\t" . '</td>' . "\r\n" .
                     '</tr>' . "\r\n"; 
            return $html;
        }

        function getValue() {

            if (isset($_POST[$this->options['meta_key'] .'_'.$this->options['id']])) {
                $this->value = $_POST[$this->options['meta_key'] .'_'.$this->options['id']];
            }
            if (!empty($this->value)) {
               $this->value = implode(',', $this->value);
            } else {
                $this->value = '';
            }
            $this->sanitize();
        }

        function check() {
            if (isset($_POST[$this->options['meta_key'] .'_'.$this->options['id']])) {
                $this->value = 1;
            } else {
                $this->value = 0;
            }
            return true;
        }


    }
endif;