<?php

// Display serialized data in HTML
function book_an_appointment_961_booking_render_content_html($data) {
    
    $data = unserialize($data);
    
    $html = '<strong>'.$data['name'].'</strong>' .
            '<div class="small">'.$data['phone'] . '</div>' .
            '<div class="small"><a href="mailto:'.$data['email'].'">'.$data['email'].'</a></div>';    
    
    return $html;
}
add_filter( 'book_an_appointment_961_booking_content', 'book_an_appointment_961_booking_render_content_html', 10, 1 );

function book_an_appointment_961_month_table_before($month) {
    
    $options = book_an_appointment_961_get_options();
    $html = "\r\n". '<table data-month="'.$month.'">' . "\r\n" .
            "\t" . '<caption>'.date_i18n($options['date_format'], strtotime($month.'-01')).'</caption>' . "\r\n";
    
    return $html;
}
add_filter( 'book_an_appointment_month_table_before', 'book_an_appointment_961_month_table_before', 10, 1 );

function book_an_appointment_961_month_table_after() {
    
    $html = '</table>' . "\r\n";
    
    return $html;
}
add_filter( 'book_an_appointment_month_table_after', 'book_an_appointment_961_month_table_after', 10 );

function book_an_appointment_961_month_table_header($days) {

    $html = "\t" . '<thead>' . "\r\n" . 
            "\t\t" . '<tr>' . "\r\n" . 
            "\t\t\t" . '<th>' .implode('</th>'."\r\n".'<th>', $days) . '</th>' . "\r\n" .
            "\t\t" . '<tr>' . "\r\n" .
            "\t" . '</thead>' . "\r\n" . 
            "\t" . '<tbody>' . "\r\n";

    return $html;
}
add_filter( 'book_an_appointment_month_table_header', 'book_an_appointment_961_month_table_header', 10, 1 );

function book_an_appointment_961_week_before() {
    return "\t\t" . '<tr>' . "\r\n";
}
add_filter( 'book_an_appointment_week_before', 'book_an_appointment_961_week_before', 10);

function book_an_appointment_961_week_after() {
    return "\t\t" . '</tr>' . "\r\n";
}
add_filter( 'book_an_appointment_week_before', 'book_an_appointment_961_week_after', 10);

function book_an_appointment_961_empty_day() {
    return "\t\t\t" . '<td>&nbsp;</td>' . "\r\n";
}
add_filter( 'book_an_appointment_empty_day', 'book_an_appointment_961_empty_day', 10);

function book_an_appointment_961_one_day($class, $script, $id, $day) {
    
    $html = "\t\t\t" . '<td class="'.implode(' ', $class).'" '.$script.' data-day="'.$id.'">'.$day.'</td>' . "\r\n";
    
    return $html;
}
add_filter( 'book_an_appointment_one_day', 'book_an_appointment_961_one_day', 10, 4);

function book_an_appointment_961_prev_link($month, $script, $mode) {
    
    $html = '';
    if (($mode == 'time') and ($month > date('Y-m'))) {
        $prev = date('Y-m', strtotime('-1 month', strtotime($month.'-01')));
        $html = "\t\t\t\t" . '<div class="prev_month" '.$script.'>' . "\r\n" . 
                "\t\t\t\t\t" . '<span class="dashicons dashicons-arrow-left"></span>' . "\r\n" . 
                "\t\t\t\t\t" . date_i18n('F', strtotime($prev)) . "\r\n" .
                "\t\t\t\t" . '</div>' . "\r\n";
    }    
    return $html;
}
add_filter( 'book_an_appointment_prev_link', 'book_an_appointment_961_prev_link', 10, 3);

function book_an_appointment_961_next_link($month, $script) {
    
    $next = date('Y-m', strtotime('+1 month', strtotime($month.'-01')));
    $html = "\t\t\t\t" . '<div class="next_month" '.$script.'>' . "\r\n" . 
            "\t\t\t\t\t" . date_i18n('F', strtotime($next)) . "\r\n" .
            "\t\t\t\t\t" . '<span class="dashicons dashicons-arrow-right"></span>' . "\r\n" . 
            "\t\t\t\t" . '</div>' . "\r\n";
    
    return $html;
}
add_filter( 'book_an_appointment_next_link', 'book_an_appointment_961_next_link', 10, 2);


function book_an_appointment_961_month_table_footer($prev, $next) {
    
    $html = "\t" . '</tbody>' . "\r\n" .
            "\t" . '<tfoot>' . "\r\n" .
            "\t\t" . '<tr>' . "\r\n" .
            "\t\t\t" . '<td colspan="7">' . "\r\n" .
            $prev . 
            $next .
            "\t\t\t" . '</td>' . "\r\n" .
            "\t\t" . '</tr>' . "\r\n" .
            "\t" . '</tfoot>' . "\r\n";
    
    return $html;
}
add_filter( 'book_an_appointment_month_table_footer', 'book_an_appointment_961_month_table_footer', 10, 2);

function book_an_appointment_961_one_time($time, $script, $class = '') {
    
    $html = '<div '.$script.' class="appointment-time '.$class.'" data-time="'.$time.'">'.$time.'</div>';
    return $html;
}
add_filter( 'book_an_appointment_one_time', 'book_an_appointment_961_one_time', 10, 3);

function book_an_appointment_961_show_error($text) {
    
    $html = '<div class="alert alert-warning" role="alert">'.$text.'</div>';
    
    return $html;
}
add_filter( 'book_an_appointment_show_error', 'book_an_appointment_961_show_error', 10, 1);

function book_an_appointment_961_before_confirmation_mail($token, $data) {

    return $data;    
}
add_filter('book_an_appointment_before_confirmation_mail', 'book_an_appointment_961_before_confirmation_mail', 10, 2);


function book_an_appointment_961_modify_args_before_form_render($args) {
    return $args;        
}
add_filter('book_an_appointment_modify_args_before_form_render', 'book_an_appointment_961_modify_args_before_form_render', 10, 1);

function book_an_appointment_961_before_event_generate($data) {
    // event.ics data manipulation
    // $data['location'] = 'my location address';
    return $data;
}
add_filter( 'book_an_appointment_before_event_generate', 'book_an_appointment_961_before_event_generate', 10, 1 );


/* Actions */


/*
function book_an_appointment_961_after_user_confirmation($token) {

    [...]
      
}
add_action('book_an_appointment_after_user_confirmation', 'book_an_appointment_961_after_user_confirmation', 10, 1);
*/

/*
function book_an_appointment_961_after_user_cancelled($token) {

    return null;    
}
add_action('book_an_appointment_after_user_cancelled', 'book_an_appointment_961_after_user_cancelled', 10, 1);
*/
